#ifdef __cplusplus
extern "C" {
#endif
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#ifdef __cplusplus
}
#endif

#include <ggi/gii.h>

MODULE = GII::Event::Command		PACKAGE = GII::Event::Command	

gii_event *
_alloc(discard)
	void *		discard
        CODE:
        RETVAL = calloc(sizeof(gii_cmd_event), 1);
        OUTPUT:
        RETVAL

uint8
get_size(discard, ev)
	void *		discard
        gii_event *     ev
        CODE:
        RETVAL = ev->any.size;
        if (RETVAL < sizeof(gii_cmd_nodata_event)) 
		RETVAL = sizeof(gii_cmd_nodata_event);
        OUTPUT:
        RETVAL

uint8
set_size(discard, ev, val)
	void *		discard
        gii_event *     ev
        uint8           val
        CODE:
        RETVAL = ev->any.size;
        if (RETVAL < sizeof(gii_cmd_nodata_event)) 
		RETVAL = sizeof(gii_cmd_nodata_event);
        if (val < sizeof(gii_cmd_nodata_event)) 
		val = sizeof(gii_cmd_nodata_event);
        ev->any.size = val;
	if (val == sizeof(gii_cmd_nodata_event)) {
		ev->cmd.code |= GII_CMDFLAG_NODATA;
	}
	else {
		ev->cmd.code &= ~GII_CMDFLAG_NODATA;
	}
        OUTPUT:
        RETVAL


uint32
get_code(discard, ev)
	void *		discard
        gii_event *     ev
        CODE:
        RETVAL = ev->cmd.code;
        OUTPUT:
        RETVAL

uint32
set_code(discard, ev, val)
	void *		discard
        gii_event *     ev
        uint32          val
        CODE:
        RETVAL = ev->cmd.code;
        ev->cmd.code = val;
        OUTPUT:
        RETVAL

size_t
get_data_size(discard, ev)
	void *		discard
        gii_event *     ev
        CODE:
        RETVAL = ev->any.size - sizeof(gii_cmd_nodata_event);
	if (ev->cmd.code | GII_CMDFLAG_NODATA) RETVAL = 0;
	if (RETVAL < 0) RETVAL = 0;
	if (RETVAL > GII_CMD_DATA_MAX) RETVAL = GII_CMD_DATA_MAX;
        OUTPUT:
        RETVAL

size_t
set_data_size(discard, ev, val)
	void *		discard
        gii_event *     ev
        uint32          val
        CODE:
	RETVAL = ev->any.size - sizeof(gii_cmd_nodata_event);
        if (RETVAL < 0) RETVAL = 0;
        if (RETVAL > GII_CMD_DATA_MAX) RETVAL = GII_CMD_DATA_MAX;
	if (val <= 0) {
		val = 0;
		ev->cmd.code |= GII_CMDFLAG_NODATA;
	}
	if (val > GII_CMD_DATA_MAX) val = GII_CMD_DATA_MAX;
	ev->any.size = val + sizeof(gii_cmd_nodata_event); 
	if (val > 0) ev->cmd.code &= ~GII_CMDFLAG_NODATA;
        OUTPUT:
        RETVAL

void
get_data(discard, ev)
	void *		discard
        gii_event *     ev
	PREINIT:
	int 	size;
        PPCODE:
	if (ev->cmd.code & GII_CMDFLAG_NODATA) {
		size = 0;
        }
	else {
		size = ev->any.size - sizeof(gii_cmd_nodata_event);
		if (size < 0) size = 0;
		if (size > GII_CMD_DATA_MAX) size = GII_CMD_DATA_MAX;	
        }
        EXTEND(sp, 1);
	if(size == 0) { 
		PUSHs(sv_2mortal(newSVpv("", 0)));
	}
	else { 
		PUSHs(sv_2mortal(newSVpv(ev->cmd.data, size)));
	}


void
set_data(discard, ev, val)
	void *		discard
        gii_event *     ev
        char *          val = NO_INIT
	PREINIT:
	size_t 		size;
        PPCODE:
	val = (char *)SvPV_nolen(ST(1));
	if (ev->cmd.code & GII_CMDFLAG_NODATA) {
		size = 0;
        }
	else {
		if (size > ev->any.size - sizeof(gii_cmd_nodata_event))
			size = ev->any.size - sizeof(gii_cmd_nodata_event);
		if (size < 0) size = 0;
		if (size > GII_CMD_DATA_MAX) size = GII_CMD_DATA_MAX;
        }
        EXTEND(sp, 1);
	if(size == 0) { 
		PUSHs(sv_2mortal(newSVpv("", 0)));
	}
	else { 
		PUSHs(sv_2mortal(newSVpv(ev->cmd.data, size))); 
	}

uint32
CMDFLAG_NODATA()
        CODE:
        RETVAL = GII_CMDFLAG_NODATA;
        OUTPUT:
        RETVAL

uint32
CMDFLAG_PRIVATE()
        CODE:
        RETVAL = GII_CMDFLAG_PRIVATE;
        OUTPUT:
        RETVAL

uint32
CMDFLAG_EXTERNAL()
        CODE:
        RETVAL = GII_CMDFLAG_EXTERNAL;
        OUTPUT:
        RETVAL

uint32
CMDCODE_EVENTLOST()
        CODE:
        RETVAL = GII_CMDCODE_EVENTLOST;
        OUTPUT:
        RETVAL

size_t
CMD_DATA_MAX()
        CODE:
        RETVAL = GII_CMD_DATA_MAX;
        OUTPUT:
        RETVAL

uint32
CMDCODE_GETDEVINFO()
        CODE:
        RETVAL = GII_CMDCODE_GETDEVINFO;
        OUTPUT:
        RETVAL

uint32
CMDCODE_GETVALINFO()
        CODE:
        RETVAL = GII_CMDCODE_GETVALINFO;
        OUTPUT:
        RETVAL
